{bot}
{BWORLD is an irc operator service, similar to UWorld.}

(*
 *  bserv, Internet Relay Chat services, bworldbot.pas
 *  Copyright (C) 2002 Bas Steendijk
 *
 *  modifications by peter green
 *
 *  this unit is the main unit of the BWORLD bot
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *)


unit bworldbot;

interface

uses buser,bconsts,sysutils;

const
  commandsfile='bworld.com.ini';
  glinelevelsfile='bworld.levels.gline.ini';
  configfile='bworld.ini';
  cfgtag='[bworld]';
  accountsfile='bworld.accounts.ini';
  glistfile='bworld.gline.ini';
  jupelistfile='bworld.jupe.ini';
  channelsfile='bworld.channels.ini';
  exceptionfile='bworld.exception.ini';
  bworldbotlogfile='bworld.log';

procedure onsendburst;
procedure ondisconnect;
procedure onstartup;
procedure bworldbotshutdown;
procedure ontimer;
procedure onnewuser(us:tuser);
procedure ondestroyuser(us:tuser);
procedure onrehash;

procedure savecmd;
procedure loadcmd;
function validcomname(s:string):boolean;

procedure deauth(us:tuser);

var
  mybot:tuser;  {this unit has one bot, pointer to tuser for bot}

{==============================================================================}
implementation

uses
  bconfig,bservicemngr,bparse,bcmds,bstuff,bchannel,btime,b_gline,passcryp,
  bworldjupe,bworldaccount,blinklist,bcrash,bservunit,bworldchan,
  bworldexception,unitbanmask,boptiontable,bsetcommand;

{info commands}
procedure priv_showcommands(sptr:tuser;parc:integer;parv:pparams;const msg:string);forward;
procedure priv_whois(sptr:tuser;parc:integer;parv:pparams;const msg:string);forward;
procedure priv_findnum(sptr:tuser;parc:integer;parv:pparams;const msg:string);forward;
procedure priv_lusers(sptr:tuser;parc:integer;parv:pparams;const msg:string);forward;
procedure priv_chaninfo(sptr:tuser;parc:integer;parv:pparams;const msg:string);forward;
procedure priv_mem(sptr:tuser;parc:integer;parv:pparams;const msg:string);forward;

{ircop commands}
procedure priv_kill(sptr:tuser;parc:integer;parv:pparams;const msg:string);forward;
procedure priv_raw(sptr:tuser;parc:integer;parv:pparams;const msg:string);forward;
procedure priv_mode(sptr:tuser;parc:integer;parv:pparams;const msg:string);forward;
procedure priv_opchan(sptr:tuser;parc:integer;parv:pparams;const msg:string);forward;
procedure priv_invite(sptr:tuser;parc:integer;parv:pparams;const msg:string);forward;

{channel power (opall, kickall, chankill)}
procedure priv_kickall(sptr:tuser;parc:integer;parv:pparams;const msg:string);forward;
procedure priv_opall(sptr:tuser;parc:integer;parv:pparams;const msg:string); forward;
procedure priv_deopall(sptr:tuser;parc:integer;parv:pparams;const msg:string); forward;
procedure priv_clearmode(sptr:tuser;parc:integer;parv:pparams;const msg:string); forward;
procedure priv_clearbans(sptr:tuser;parc:integer;parv:pparams;const msg:string); forward;
procedure priv_op(sptr:tuser;parc:integer;parv:pparams;const msg:string); forward;
procedure priv_deop(sptr:tuser;parc:integer;parv:pparams;const msg:string); forward;

{gline management}
procedure priv_glist(sptr:tuser;parc:integer;parv:pparams;const msg:string);forward;
procedure priv_gline(sptr:tuser;parc:integer;parv:pparams;const msg:string);forward;
procedure priv_remgline(sptr:tuser;parc:integer;parv:pparams;const msg:string);forward;
procedure priv_refreshg(sptr:tuser;parc:integer;parv:pparams;const msg:string);forward;

{jupe management}
(*
procedure priv_jupe(sptr:tuser;parc:integer;parv:pparams;msg:string);forward;
procedure priv_unjupe(sptr:tuser;parc:integer;parv:pparams;msg:string);forward;
*)
procedure priv_rehash(sptr:tuser;parc:integer;parv:pparams;const msg:string);forward;
procedure priv_set(sptr:tuser;parc:integer;parv:pparams;const msg:string);forward;
procedure priv_globalset(sptr:tuser;parc:integer;parv:pparams;const msg:string);forward;
procedure priv_save(sptr:tuser;parc:integer;parv:pparams;const msg:string);forward;
procedure priv_restart(sptr:tuser;parc:integer;parv:pparams;const msg:string);forward;
procedure priv_die(sptr:tuser;parc:integer;parv:pparams;const msg:string);forward;
procedure priv_diebot(sptr:tuser;parc:integer;parv:pparams;const msg:string);forward;
procedure priv_settime(sptr:tuser;parc:integer;parv:pparams;const msg:string);forward;

{own account}
procedure priv_login(sptr:tuser;parc:integer;parv:pparams;const msg:string);forward;
procedure priv_deauth(sptr:tuser;parc:integer;parv:pparams;const msg:string);forward;
procedure priv_newpass(sptr:tuser;parc:integer;parv:pparams;const msg:string);forward;

{global bot management}
procedure priv_level(sptr:tuser;parc:integer;parv:pparams;const msg:string);forward;
procedure priv_chcomname(sptr:tuser;parc:integer;parv:pparams;const msg:string);forward;
procedure priv_mkpasswd(sptr:tuser;parc:integer;parv:pparams;const msg:string);forward;

{oper accounts management}
procedure priv_addoper(sptr:tuser;parc:integer;parv:pparams;const msg:string);forward;
procedure priv_deloper(sptr:tuser;parc:integer;parv:pparams;const msg:string);forward;
procedure priv_operlist(sptr:tuser;parc:integer;parv:pparams;const msg:string);forward;
procedure priv_operinfo(sptr:tuser;parc:integer;parv:pparams;const msg:string);forward;
procedure priv_modoper(sptr:tuser;parc:integer;parv:pparams;const msg:string);forward;

{channel management}
procedure priv_listchannels(sptr:tuser;parc:integer;parv:pparams;const msg:string);forward;
procedure priv_addchannel(sptr:tuser;parc:integer;parv:pparams;const msg:string);forward;
procedure priv_delchannel(sptr:tuser;parc:integer;parv:pparams;const msg:string);forward;

procedure priv_exceptionlist(sptr:tuser;parc:integer;parv:pparams;const msg:string);forward;
procedure priv_addexception(sptr:tuser;parc:integer;parv:pparams;const msg:string);forward;
procedure priv_delexception(sptr:tuser;parc:integer;parv:pparams;const msg:string);forward;

{centralized error replies}
function error_nosuchaccount(const name:string):string;
begin
  result := 'No such account: '+name;
end;

function error_nosuchchannel(const name:string):string;
begin
  result := 'No such channel: '+name;
end;

function error_nosuchnick(const name:string):string;
begin
  result := 'No such nick: '+name;
end;

type
  tcmdproc=procedure(sptr:tuser;parc:integer;parv:pparams;const msg:string);
  tcmdtab=record
    cmd:string;
    customcmd:string;
    level:integer;
    p:tcmdproc;
    enabled:boolean;
    info:string;
  end;
  taccount=class
    name:string;
    info:string;
    password:string; {crypted password using salt MD5}
    level:integer;
    user:tuser; {who is logged in; only one for now, call to ondestroyuser is needed at the begin of tuser.destroy}
  end;

var
  cmd:string; {currently called cmd}
  autosavenextts:integer;

{level -1 = always allow, even if not logged in}

const
  botmaxcmd=46;

cmdtab:array[0..botmaxcmd] of tcmdtab=(
(cmd:'LOGIN';level:-1;p:priv_login;info:'login to your account'),
(cmd:'DEAUTH';level:0;p:priv_deauth;info:'log out'),
(cmd:'HELP';level:-1;p:priv_showcommands;info:'list all commands available to you with info'),
(cmd:'MKPASSWD';level:0;p:priv_mkpasswd;info:'crypt a password'),
(cmd:'LUSERS';level:0;p:priv_lusers;info:'show number of users on the net'),
(cmd:'WHOIS';level:100;p:priv_whois;info:'extended whois, including the secret channels someone is in'),
(cmd:'TRANSLATE';level:100;p:priv_findnum;info:'convert names to/from numerics'),
(cmd:'GLIST';level:100;p:priv_glist;info:'show G-lines'),
(cmd:'CHANINFO';level:100;p:priv_chaninfo;info:'show complete information about a channel'),

(cmd:'KILL';level:200;p:priv_kill;info:'Kill a user'),
(cmd:'OPCHAN';level:100;p:priv_opchan;info:'Op someone in an opless channel'),
(cmd:'INVITE';level:200;p:priv_invite;info:'Invite yourself to a channel'),

(cmd:'GLINE';level:300;p:priv_gline;info:'Add a G-line'),
(cmd:'UNGLINE';level:300;p:priv_remgline;info:'Remove a G-line'),
(cmd:'REFRESHG';level:200;p:priv_refreshg;info:'re-send all G-lines'),

(cmd:'LISTCHANNELS';level:100;p:priv_listchannels;info:'list channels managed by BWorld'),
(cmd:'ADDCHANNEL';level:800;p:priv_addchannel;info:'add channel managed by BWorld'),
(cmd:'DELCHANNEL';level:800;p:priv_delchannel;info:'remove a channel managed by BWorld'),

(*(cmd:'JUPE';level:800;p:priv_jupe),
(cmd:'UNJUPE';level:800;p:priv_unjupe),*)

(cmd:'MODE';level:800;p:priv_mode;info:'change channel modes'),
(cmd:'KICKALL';level:400;p:priv_kickall;info:'kick everyone in a channel'),
(cmd:'OPALL';level:400;p:priv_opall;info:'op everyone in a channel'),
(cmd:'DEOPALL';level:400;p:priv_deopall;info:'deop everyone in a channel'),
(cmd:'CLEARMODES';level:400;p:priv_clearmode;info:'clear all modes on a modes'),
(cmd:'CLEARBANS';level:400;p:priv_clearbans;info:'remove all bans on a channel'),
(cmd:'OP';level:400;p:priv_op;info:'op someone in a channel'),
(cmd:'DEOP';level:400;p:priv_deop;info:'deop someone on a channel'),

(cmd:'SET';level:1000;p:priv_set;info:'view/change configuration of BWorld'),
(cmd:'GSET';level:1000;p:priv_globalset;info:'view/change configuration of the services server'),
(cmd:'SETTIME';level:900;p:priv_settime;info:'send settime message'),
(cmd:'QUOTE';level:950;p:priv_raw;info:'send raw message'),
(cmd:'REHASH';level:900;p:priv_rehash;info:'reload files of BWorld bot'),
(cmd:'SAVE';level:900;p:priv_save;info:'save files of BWorld bot'),
(cmd:'RESTART';level:900;p:priv_restart;info:'restart BWorld bot'),
(cmd:'DIE';level:900;p:priv_die;info:'stop services server'),
(cmd:'DIEBOT';level:900;p:priv_diebot;info:'stop BWorld bot'),
(cmd:'CHLEVEL';level:1000;p:priv_level;info:'show/change access levels of commands'),
(cmd:'CHCOMNAME';level:1000;p:priv_chcomname;info:'change name of commands'),
(cmd:'MEM';level:900;p:priv_mem;info:'show memory usage status'),
(cmd:'EXCEPTIONLIST';level:100;p:priv_exceptionlist;info:'show exceptions of clone limit G-line check'),
(cmd:'ADDEXCEPTION';level:800;p:priv_addexception;info:'add exception of clone limit check'),
(cmd:'DELEXCEPTION';level:800;p:priv_delexception;info:'remove exception of clone limit check'),

(cmd:'ADDOPER';level:1000;p:priv_addoper;info:'add BWorld account'),
(cmd:'DELOPER';level:1000;p:priv_deloper;info:'remove BWorld account'),
(cmd:'MODOPER';level:1000;p:priv_modoper;info:'change BWorld account'),
(cmd:'OPERLIST';level:0;p:priv_operlist;info:'list BWorld accounts'),
(cmd:'OPERINFO';level:0;p:priv_operinfo;info:'show info about one BWorld account'),
(cmd:'NEWPASS';level:-1;p:priv_newpass;info:'change your own password')
);
{
G-line rules:

- even a lower level ircop may be able to use GLINE
but short duration only
}

const
  maxoptiontable=8;

var
  {config file options for this service unit}
  locopt:record
    nick:string;
    userid:string;
    info:string;
    operchannel:string;
    operlevel:integer;
    firewall:boolean;
    clonelimit:integer;
    cloneduration:string;
    clonereason:string;
  end;

  optiontable:array[0..maxoptiontable] of Toptionentry=(
  (
  p:@locopt.nick;
  typ:opt_str;
  name:'nick';
  info:'BWorld bot''s nick';
  def_s:'BWorld'),
  (
  p:@locopt.userid;
  typ:opt_str;
  name:'userid';
  info:'BWorld bot''s userid (empty for global userid setting)';
  def_s:''),
  (
  p:@locopt.info;
  typ:opt_str;
  name:'info';
  info:'BWorld bot''s realname';
  def_s:'beware IRC Operator Service'),
  (
  p:@locopt.operchannel;
  typ:opt_str;
  name:'operchannel';
  info:'BWorld bot event log channel';
  def_s:'#Admin'),
  (
  p:@locopt.operlevel;
  typ:opt_int;
  name:'OperLevel';
  info:'BWorld access level for opers who are not logged in';
  def_i:maxlevel div 10),
  (
  p:@locopt.firewall;
  typ:opt_bool;
  name:'firewall';
  info:'ignore (don''t reply) any message from someone who is not oper, and not logged in';
  def_b:true),
  (
  p:@locopt.clonelimit;
  typ:opt_int;
  name:'clonelimit';
  info:'maximum users from one IP before setting G-line';
  def_i:20),
  (
  p:@locopt.cloneduration;
  typ:opt_str;
  name:'cloneduration';
  info:'duration in seconds of clone auto G-line';
  def_s:'1h'),
  (
  p:@locopt.clonereason;
  typ:opt_str;
  name:'clonereason';
  info:'reason for clone G-line';
  def_s:'automatic clone ban')
  );

  up:boolean;   {the service unit is enabled}

  srvunit:tserviceunit;
  currentoperchannel:string;
  sendtalk:string;
  prefix:string;  {the ":sender " part of a message sent by this bot}

function getaccountfromuser(us:tuser):tbworldaccount;
begin
  result := us.bottag[srvunit.num];
end;

function haslevel(us:tuser):integer;
var
  p:tbworldaccount;
begin
  result := -1;
  if isoper(us) then result := locopt.operlevel;
  p := getaccountfromuser(us);
  if p <> nil then begin
    if p.level > result then result := p.level;
  end;
end;

procedure logaction(sptr:tuser;s:string);
var
  from:string;
  p:tbworldaccount;
begin

  if sptr <> nil then begin
    from := nickuserhost(sptr);
    p := getaccountfromuser(sptr);
    if p <> nil then begin
      from := from + '['+p.name+']';
    end;
    from := from + ' ';
  end else begin
    from := '';
  end;

  if currentoperchannel <> '' then send(prefix+TOK_NOTICE+' '+currentoperchannel+' :'+from+s);
  filelog(bworldbotlogfile,from+s);
end;

(*
procedure deauth(us:tuser);
var
  t:tbworldaccount;
begin
  t := us.bottag[srvunit.num];
  if t = nil then exit;
  assert(t.user = us,'bworld.deauth: account.user and user.account don''t match','');

  t.user := nil;
  us.bottag[srvunit.num] := nil;
end;
*)
procedure deauth(us:tuser);
var
  t:tbworldaccount;
begin
  t := getaccountfromuser(us);
  if t = nil then exit;

  assert(t.removeuser(us),'BWorld.deauth: user not in account','');

  us.bottag[srvunit.num] := nil;
end;


function getloginname(us:tuser):string;
var
  t:tbworldaccount;
begin
  result := '';
  t := getaccountfromuser(us);
  if t = nil then exit;
  result := t.name;
end;

function ismortal(us:tuser):boolean;
begin
  result := locopt.firewall;
  if isoper(us) then result := false;
  if getaccountfromuser(us) <> nil then result := false;
end;

procedure bworldbotinit;
begin
  {fill in some defaults in case they cant be read from config file}

  optiontable_default(optiontable,maxoptiontable);
  optiontable_load(optiontable,maxoptiontable,configfile,cfgtag);

  loadcmd;
  loadbworldaccount(accountsfile);
  loadgline(glistfile);
  loadchan(channelsfile);
  loadexception(exceptionfile);

  autosavenextts := unixtime+opt.autosave;
  {loadjupe}
end;

procedure bworldbotsave;
begin
  autosavenextts := unixtime+opt.autosave;
  savegline(glistfile);
  savechan(channelsfile);
{  savejupe(jupelistfile);}
  savecmd;
  savebworldaccount(accountsfile);
  saveexception(exceptionfile);
  optiontable_save(optiontable,maxoptiontable,configfile,cfgtag);
end;

procedure onsave;
begin
  logaction(nil,'Received SAVE signal');
  bworldbotsave;
end;

procedure priv_login(sptr:tuser;parc:integer;parv:pparams;const msg:string);
const
  loginfailed='Login failed';
var
  a:integer;
  p:tbworldaccount;
  sl:tstringlinklist;
  s1,s2,s3:string;

procedure failed;
begin
  if not ismortal(sptr) then send(sendtalk+loginfailed);
end;

begin
  {
  check:
  - is already logged in to anything
  - someone is already logged in to account
  - is ircop
  - mask
  - password.

  then associate user with account and account with user
  }

  if getaccountfromuser(sptr) <> nil then begin
    send(sendtalk+'You are already logged in, DEAUTH first.');
    exit;
  end;

  if (parv[2] = '') or (parc < 3) then begin
    if not ismortal(sptr) then send(sendtalk+cmd+' <IDnick> <password>');
    exit;
  end;

  p := findbworldaccount(parv[1]);
  if p = nil then begin
    failed;
    exit;
  end;

  {if operonly: check}
  if not isoper(sptr) then if p.operonly then begin
    logaction(sptr,'Failed login to '+p.name+': not IRCop');
    failed;
    exit;
  end;

  s1 := ircupper(sptr.name+'!'+sptr.userid+'@'+sptr.host);
  s2 := ircupper(sptr.name+'!'+sptr.userid+'@'+ipbintostr(sptr.binip));
  sl := p.mask;
  a := 0;
  while sl <> nil do begin
    s3 := ircupper(sl.s);
    if maskmatch(s3,s1) or maskmatch(s3,s2) then begin
      a := 1;
      break;
    end;
    sl := tstringlinklist(sl.next);
  end;
  if a = 0 then begin
    logaction(sptr,'Failed login to '+p.name+': mask does not match');
    failed;
    exit;
  end;

  if (p.password = '') then begin
    logaction(sptr,'Failed login to '+p.name+': account disabled.');
    failed;
    exit;
  end;

  if (not passmatch(parv[2],p.password)) or (p.password = '') then begin
    logaction(sptr,'Failed login to '+p.name+': password incorrect');
    failed;
    exit;
  end;

  sptr.bottag[srvunit.num] := p;
  p.adduser(sptr);
  logaction(sptr,'LOGIN');
  send(sendtalk+'Login OK');
end;

procedure priv_newpass(sptr:tuser;parc:integer;parv:pparams;const msg:string);
var
  p:tbworldaccount;

begin
  if (parv[3] = '') or (parc < 4) then begin
    send(sendtalk+cmd+' <old> <new> <new>');
    exit;
  end;

  p := getaccountfromuser(sptr);
  if p = nil then begin
    send(sendtalk+'You are not logged in.');
    exit;
  end;

  if (not passmatch(parv[1],p.password)) or (p.password = '') then begin
    send(sendtalk+'password incorrect');
    exit;
  end;

  if (parv[2] <> parv[3]) then begin
    send(sendtalk+'new password mismatch');
    exit;
  end;

  p.password := passnewcrypt(parv[3]);

  logaction(sptr,'NEWPASS');
  send(sendtalk+'Your password has been changed.');
end;

procedure priv_deauth(sptr:tuser;parc:integer;parv:pparams;const msg:string);
begin

  if getaccountfromuser(sptr) = nil then begin
    send(sendtalk+'You are not logged in.');
    exit;
  end;

  deauth(sptr);
  send(sendtalk+'You are logged off.');
end;


{===================================================================== info commands}

procedure priv_showcommands(sptr:tuser;parc:integer;parv:pparams;const msg:string);
var
  a,b,c:integer;
  s:string;
begin
  send(sendtalk+'The following commands are available to you:');
  send(sendtalk+'use /msg '+mybot.name+' <command> for help on a specific command');
  send(sendtalk+'--------------------------------------------');
  b := haslevel(sptr);

  c := 1;
  for a := 0 to botmaxcmd do if b >= cmdtab[a].level then begin
    if length(cmdtab[a].customcmd) > c then c := length(cmdtab[a].customcmd);
  end;

  for a := 0 to botmaxcmd do begin
    if b >= cmdtab[a].level then begin
(*      s := s+cmdtab[a].customcmd+' ';
      if length(s) > 50 then begin
        send(sendtalk+s);
        s := '';
      end*)
      s := cmdtab[a].customcmd;
      while length(s) < c do s := s + ' ';
      send(sendtalk+s+' '+cmdtab[a].info+' '+inttostr(cmdtab[a].level));
    end;
  end;
{  if s <> '' then send(sendtalk+s);}
end;

procedure priv_whois(sptr:tuser;parc:integer;parv:pparams;const msg:string);
var
  s:string;
  us:tuser;
  uc:tuserchan;
begin
    if (parv[1] = '') or (parc < 2) then begin
      send(sendtalk+cmd+' <nick>');
      exit;
    end;

    us := findname(parv[1]);
    if us = nil then begin
      send(sendtalk+error_nosuchnick(parv[1]));
      exit
    end;
    logaction(sptr,'WHOIS '+parv[1]);
    send(sendtalk+us.name+'!'+us.userid+'@'+us.host+' ['+ipbintostr(us.binip)+'] '+us.fullname);
    send(sendtalk+'  '+us.idstr+' '+inttostr(us.ipcheck.online)+' '+inttostr(us.ts)+' ('+timestrshort(us.ts)+')');
    send(sendtalk+'  on server: '+tuser(us.server.us).name);
    if us.account <> '' then  send(sendtalk+'  account: '+us.account);
    send(sendtalk+'  modes:'+usermodestr(us));
    s := '';
    uc := tuserchan(us.channel);
    while uc <> nil do begin
      s := s + ' ';

        if flag_isset(uc.flags,userchanflag_op) then s := s + '@'
        else if flag_isset(uc.flags,userchanflag_voice) then s := s + '+';
        s := s + uc.ch.name;

      uc := tuserchan(uc.next);
      if length(s) > 400 then begin
        send(sendtalk+'  On channels:'+s);
        s := '';
      end;
    end;
    if s <> '' then send(sendtalk+'  On channels:'+s);
end;

procedure priv_findnum(sptr:tuser;parc:integer;parv:pparams;const msg:string);
var
  us:tuser;
  bool:boolean;
begin
  if (parv[1] = '') or (parc < 2) then begin
    send(sendtalk+cmd+' <numnick>');
    exit;
  end;
  bool := false;
  us := findnumeric(parv[1]);
  if us <> nil then begin
    send(sendtalk+us.idstr+' '+us.name);
    bool := true;
  end;

  us := findname(parv[1]);
  if us <> nil then begin
    send(sendtalk+us.idstr+' '+us.name);
    bool := true;
  end;

  if not bool then send(sendtalk+error_nosuchnick(parv[1]));
end;

procedure priv_lusers(sptr:tuser;parc:integer;parv:pparams;const msg:string);
begin
  send(sendtalk+'There are '+
  inttostr(count.globalclients-count.invisible)+' users and '+
  inttostr(count.invisible)+' invisible on '+
  inttostr(count.globalservers)+' servers');
  send(sendtalk+inttostr(count.globalclients)+' global users');

  send(sendtalk+inttostr(count.oper)+' Operator(s) online');
  send(sendtalk+inttostr(count.channels)+' channels formed');
end;

procedure priv_chaninfo(sptr:tuser;parc:integer;parv:pparams;const msg:string);
var
  ch:tchannel;
  uc:tuserchan;
  s:string;
  ban:tban;
begin
    if (parv[1] = '') or (parc < 2) then begin
      send(sendtalk+cmd+' <channel>');
      exit;
    end;

    ch := findchan(parv[1]);
    if ch = nil then begin
      send(sendtalk+error_nosuchchannel(parv[1]));
      exit
    end;
    send(sendtalk+ch.name);
    send(sendtalk+'  TS: '+inttostr(ch.ts)+' ('+timestrshort(ch.ts)+')');
    send(sendtalk+'  modes:'+chanmodestr(ch,true));
    send(sendtalk+'  '+inttostr(ch.usercount)+' users');

    s := '';
    uc := tuserchan(ch.user);
    while uc <> nil do begin
      s := s + ' ';
      if flag_isset(uc.flags,userchanflag_op) then s := s + '@'
      else if flag_isset(uc.flags,userchanflag_voice) then s := s + '+';
      s := s + uc.us.name;
      uc := tuserchan(uc.next2);

      if length(s) > 400 then begin
        send(sendtalk+'  Users:'+s);
        s := '';
      end;
    end;
    if s <> '' then send(sendtalk+'  Users:'+s);


    s := '';
    ban := tban(ch.banlist);
    while ban <> nil do begin
      s := s + ' ';
      s := s + ban.mask;
      ban := tban(ban.next);

      if length(s) > 400 then begin
        send(sendtalk+'  Bans:'+s);
        s := '';
      end;
    end;
    if s <> '' then send(sendtalk+'  Bans:'+s);
end;

{===================================================================== ircop commands}

procedure priv_invite(sptr:tuser;parc:integer;parv:pparams;const msg:string);
var
  ch:tchannel;
  bool:boolean;
begin
  if (parv[1] = '') or (parc < 2) then begin
    parv[1] := currentoperchannel;
    if parv[1] = '' then begin
      send(sendtalk+'INVITE <channel>');
      exit;
    end;
  end;
  ch := findchan(parv[1]);
  if ch = nil then begin
    send(sendtalk+error_nosuchchannel(parv[1]));
    exit
  end;
  logaction(sptr,cmd+' '+ch.name);

  bool := getuserchan(mybot,ch) = nil;
  if bool then send(prefix+TOK_JOIN+' '+ch.name+' '+inttostr(irctime));
  send(prefix+TOK_INVITE+' '+sptr.name+' '+ch.name);
  if bool then send(prefix+TOK_PART+' '+ch.name);
end;


procedure priv_mode(sptr:tuser;parc:integer;parv:pparams;const msg:string);
var
  a:integer;
  us:tuser;
  ch:tchannel;
  s:string;
begin
  if (parv[2] = '') or (parc < 3) then begin
    send(sendtalk+cmd+' <channel> <params>');
    exit;
  end;
  ch := findchan(parv[1]);
  if ch = nil then begin
    send(sendtalk+error_nosuchchannel(parv[1]));
    exit;
  end;

  {convert nicks to numerics}
  for a := 2 to parc-1 do begin
    us := findname(parv[a]);
    if us <> nil then parv[a] := us.idstr;
  end;

  logaction(sptr,msg);
  s := me.idstr+' '+TOK_MODE;
  for a := 1 to parc-1 do s := s + ' '+parv[a];
  sendparse(s);
end;

procedure priv_opchan(sptr:tuser;parc:integer;parv:pparams;const msg:string);
var
  us:tuser;
  uc:tuserchan;
  ch:tchannel;
begin
  if (parv[2] = '') or (parc < 3) then begin
    send(sendtalk+cmd+' <channel> <nick>');
    exit;
  end;

  ch := findchan(parv[1]);
  if ch = nil then begin
    send(sendtalk+error_nosuchchannel(parv[1]));
    exit;
  end;

  us := findname(parv[2]);
  if us = nil then begin
    send(sendtalk+error_nosuchnick(parv[2]));
    exit;
  end;

  if getuserchan(us,ch) = nil then begin
    send(sendtalk+'user not in channel');
    exit;
  end;

  {is opless?}
  uc := tuserchan(ch.user);
  while uc <> nil do begin
    if flag_isset(uc.flags,userchanflag_op) then begin
      send(sendtalk+'Channel '+ch.name+' is NOT opless');
      exit;
    end;
    uc := tuserchan(uc.next2);
  end;

  logaction(sptr,cmd+' '+parv[1]+' '+parv[2]);

  sendparse(me.idstr+' '+TOK_MODE+' '+ch.name+' +o '+us.idstr);
  send(sendtalk+'I opped '+us.name+' on '+ch.name);
end;

procedure priv_raw(sptr:tuser;parc:integer;parv:pparams;const msg:string);
var
  s:string;
begin
  if (parv[1] = '') or (parc < 2) then begin
    send(sendtalk+cmd+' <message>');
    exit;
  end;
  s := copy(msg,pos(' ',msg)+1,500);
  logaction(sptr,cmd+' '+s);
  sendparse(s);
end;

procedure priv_kill(sptr:tuser;parc:integer;parv:pparams;const msg:string);
var
  us:tuser;
  s:string;
begin
  if (parv[2] = '') or (parc < 3) then begin
    send(sendtalk+cmd+' <nick> <reason>');
    exit;
  end;
  us := findnick(parv[1]);
  if us = nil then begin
    send(sendtalk+error_nosuchnick(parv[1]));
    exit;
  end;
  if flag_isset(us.modeflag,usermode_service) then begin
    send(sendtalk+'can''t kill a service');
    exit;
  end;
  s := copy(msg,pos(' ',msg)+1,500);
  s := copy(s,pos(' ',s)+1,500);
  logaction(sptr,cmd+' '+us.name+' ('+s+')');
  sendkill(us,mybot.name,s);
end;

{============================================================================ channel commands}

procedure priv_op(sptr:tuser;parc:integer;parv:pparams;const msg:string);
var
  us:tuser;
  ch:tchannel;
  uc:tuserchan;
  s,s2:string;
  a:integer;
procedure flushmode;
begin
  if s = '' then exit;
  sendparse(me.idstr+' '+TOK_MODE+' '+ch.name+' +'+s+s2);
  s := '';
  s2 := '';
end;
procedure opone(us:tuser;nick:string);
begin
  if us = nil then begin
    send(sendtalk+error_nosuchnick(nick));
    exit;
  end;
  if length(s) >= maxmodes then flushmode;
  s := s + 'o';
  s2 := s2 + ' '+us.idstr;
end;
begin
  s := 'OP';
  for a := 1 to parc-1 do s := s + ' '+parv[a];
  logaction(sptr,s);

  if (parv[1] = '') or (parc < 2) then begin
    us := sptr;
    uc := tuserchan(us.channel);
    while uc <> nil do begin
      if not flag_isset(uc.flags,userchanflag_op) then begin
        sendparse(me.idstr+' '+TOK_MODE+' '+uc.ch.name+' +o '+us.idstr);
      end;
      uc := tuserchan(uc.next);
    end;
  end else begin
    ch := findchan(parv[1]);
    if ch = nil then begin
      send(sendtalk+error_nosuchchannel(parv[1]));
      exit;
    end;
    s := '';
    s2 := '';
    if (parc < 3) or (parv[2] = '') then begin
      opone(sptr,'')
    end else begin
      for a := 2 to parc-1 do opone(findnick(parv[a]),parv[a]);
    end;
    flushmode;
  end;
end;

procedure priv_deop(sptr:tuser;parc:integer;parv:pparams;const msg:string);
var
  us:tuser;
  ch:tchannel;
  uc:tuserchan;
  s,s2:string;
  a:integer;
procedure flushmode;
begin
  if s = '' then exit;
  sendparse(me.idstr+' '+TOK_MODE+' '+ch.name+' -'+s+s2);
  s := '';
  s2 := '';
end;
procedure opone(us:tuser;nick:string);
begin
  if us = nil then begin
    send(sendtalk+error_nosuchnick(nick));
    exit;
  end;
  if length(s) >= maxmodes then flushmode;
  s := s + 'o';
  s2 := s2 + ' '+us.idstr;
end;
begin
  s := 'DEOP';
  for a := 1 to parc-1 do s := s + ' '+parv[a];
  logaction(sptr,s);
  if (parv[1] = '') or (parc < 2) then begin
    us := sptr;
    uc := tuserchan(us.channel);
    while uc <> nil do begin
      if flag_isset(uc.flags,userchanflag_op) then begin
        sendparse(me.idstr+' '+TOK_MODE+' '+uc.ch.name+' -o '+us.idstr);
      end;
      uc := tuserchan(uc.next);
    end;
  end else begin
    ch := findchan(parv[1]);
    if ch = nil then begin
      send(sendtalk+error_nosuchchannel(parv[1]));
      exit;
    end;
    s := '';
    s2 := '';
    if (parc < 3) or (parv[2] = '') then begin
      opone(sptr,'')
    end else begin
      for a := 2 to parc-1 do opone(findnick(parv[a]),parv[a]);
    end;
    flushmode;
  end;
end;

procedure priv_kickall(sptr:tuser;parc:integer;parv:pparams;const msg:string);
var
  ch:tchannel;
  uc:tuserchan;
  us:tuser;
  s:string;
  a:integer;
  notmatch:boolean;
begin
  if (parv[1] = '') or (parc < 2) then begin
    send(sendtalk+cmd+' <channel>');
    exit;
  end;
  ch := findchan(parv[1]);
  if ch = nil then begin
    send(sendtalk+error_nosuchchannel(parv[1]));
    exit;
  end;
  s := '';
  for a := 2 to parc-1 do begin
    if s <> '' then s := s + ' ';
    s := s + parv[a];
  end;

  logaction(sptr,cmd+' '+ch.name+' '+s);
  if s <> '' then
  s := 'Mass kick ('+s+')'
  else
  s := 'Mass kick';
  repeat

    {find first matching user (not +k and not ircop)}
    uc := tuserchan(ch.user);
    notmatch := true;
    while (uc <> nil) and (notmatch) do begin
      us := uc.us;
      notmatch := flag_isset(us.modeflag,usermode_service) or flag_isset(us.modeflag,usermode_oper);

      if not notmatch then
      sendparse(me.idstr+' '+TOK_KICK+' '+ch.name+' '+us.idstr+' :'+s);

      uc := tuserchan(uc.next2);
    end;
    if uc = nil then break;
  until false;
end;

procedure priv_opall(sptr:tuser;parc:integer;parv:pparams;const msg:string);
var
  ch:tchannel;
  s,s2:string;
  uc:tuserchan;
begin
  if (parv[1] = '') or (parc < 2) then begin
    send(sendtalk+cmd+' <channel>');
    exit;
  end;
  ch := findchan(parv[1]);
  if ch = nil then begin
    send(sendtalk+error_nosuchchannel(parv[1]));
    exit;
  end;
  logaction(sptr,cmd+' '+ch.name);
  s := '';
  s2 := '';
  uc := tuserchan(ch.user);
  while uc <> nil do begin
    if not flag_isset(uc.flags,userchanflag_op) then begin
      s := s + 'o';
      s2 := s2 + ' '+uc.us.idstr;
      if length(s) >= maxmodes then begin
        sendparse(me.idstr+' '+TOK_MODE+' '+ch.name+' +'+s+s2);
        s := '';
        s2 := '';
      end;
    end;
    uc := tuserchan(uc.next2);
  end;
  if s <> '' then sendparse(me.idstr+' '+TOK_MODE+' '+ch.name+' +'+s+s2);
end;

procedure priv_deopall(sptr:tuser;parc:integer;parv:pparams;const msg:string);
var
  ch:tchannel;
  s,s2:string;
  uc:tuserchan;
begin
  if (parv[1] = '') or (parc < 2) then begin
    send(sendtalk+cmd+' <channel>');
    exit;
  end;
  ch := findchan(parv[1]);
  if ch = nil then begin
    send(sendtalk+error_nosuchchannel(parv[1]));
    exit;
  end;
  logaction(sptr,cmd+' '+ch.name);
  s := '';
  s2 := '';
  uc := tuserchan(ch.user);
  while uc <> nil do begin
    if not (flag_isset(uc.us.modeflag,usermode_service) or flag_isset(uc.us.modeflag,usermode_oper)) then begin
      if flag_isset(uc.flags,userchanflag_op) then begin
        s := s + 'o';
        s2 := s2 + ' '+uc.us.idstr;
        if length(s) >= maxmodes then begin
          sendparse(me.idstr+' '+TOK_MODE+' '+ch.name+' -'+s+s2);
          s := '';
          s2 := '';
        end;
      end;
    end;
    uc := tuserchan(uc.next2);
  end;
  if s <> '' then sendparse(me.idstr+' '+TOK_MODE+' '+ch.name+' -'+s+s2);
end;

procedure priv_clearmode(sptr:tuser;parc:integer;parv:pparams;const msg:string);
var
  ch:tchannel;
  s:string;
begin
  if (parv[1] = '') or (parc < 2) then begin
    send(sendtalk+cmd+' <channel>');
    exit;
  end;

  ch := findchan(parv[1]);
  if ch = nil then begin
    send(sendtalk+error_nosuchchannel(parv[1]));
    exit;
  end;
  logaction(sptr,cmd+' '+ch.name);

  {$IFDEF no21011}
  s := 'mintspl';
  s2 := '';
  if ch.key <> '' then begin
    s := s + 'k';
    s2 := s2 + ' '+ch.key;
  end;
  sendparse(me.idstr+' '+TOK_MODE+' '+ch.name+' -'+s+s2);
  {$ELSE}
  if (parc < 3) then s := '' else s := parv[2];
  sendparse(me.idstr+' '+TOK_CLEARMODE+' '+ch.name+' :'+s);
  {$ENDIF}
end;

procedure priv_clearbans(sptr:tuser;parc:integer;parv:pparams;const msg:string);
var
  ch:tchannel;
begin
  if (parv[1] = '') or (parc < 2) then begin
    send(sendtalk+cmd+' <channel>');
    exit;
  end;
  ch := findchan(parv[1]);
  if ch = nil then begin
    send(sendtalk+error_nosuchchannel(parv[1]));
    exit;
  end;
  logaction(sptr,cmd+' '+ch.name);


  {$IFDEF no21011}
  while ch.banlist <> nil do begin
    b := ch.banlist;
    s := '';
    s2 := '';
    while (b <> nil) and (length(s) < maxmodes) do begin
      s := s + 'b';
      s2 := s2 + ' '+b.mask;
      b := tban(b.next);
    end;
    if s <> '' then sendparse(me.idstr+' '+TOK_MODE+' '+ch.name+' -'+s+s2);
  end;
  {$ELSE}
  sendparse(me.idstr+' '+TOK_CLEARMODE+' '+ch.name+' :b');
  {$ENDIF}

end;

{============================================================================ GLINE}

function parseduration(s:string):integer;
var
  b:integer;
  c:char;
begin
  c := s[length(s)];
  case c of
    'h':b := 3600;
    'd':b := 86400;
    'w':b := 86400*7;
    'm':b := 86400*30;
    'y':b := 86400*365;
    '0'..'9':b := 1;
  else
    b := 0;
  end;
  if b <> 1 then s := copy(s,1,length(s)-1);

  result := strtointdef(s,0)*b;
end;

function lastparam(parv:pparams;parc,first:integer):string;
var
  a:integer;
begin
  result := '';
  for a := first to parc-1 do begin
    if result <> '' then result := result + ' ';
    result := result +parv[a];
  end;
end;

procedure priv_gline(sptr:tuser;parc:integer;parv:pparams;const msg:string);
var
  s,mask:string;
  ts:integer;
  us:tuser;
begin
  if (parv[3] = '') or (parc < 4) then begin
    send(sendtalk+cmd+' <nick or mask> <duration> <reason>');
    exit;
  end;

  {if its a nick make it a host here}
  mask := parv[1];
  us := findnick(mask);
  if us <> nil then begin
    mask := '*@'+ipbintostr(us.binip);
  end;

  if not ischanprefix(mask[1]) then
  if not validglinemask(mask) then begin
    send(sendtalk+'invalid mask');
    exit;
  end;

  ts := parseduration(parv[2]);
  if ts <= 0 then exit;

  s := lastparam(parv,parc,3);

  if not validglinereason(s) then begin
    send(sendtalk+'reason must be atleast 2 words');
    exit;
  end;
  logaction(sptr,cmd+' '+parv[1]+' '+parv[2]+' ('+s+')');
  addgline(getloginname(sptr),mask,ts,s);
end;

procedure priv_remgline(sptr:tuser;parc:integer;parv:pparams;const msg:string);
var
  gl:tgline;
begin
  if (parv[1] = '') or (parc < 2) then begin
    send(sendtalk+cmd+' <mask>');
    exit;
  end;

  if not ischanprefix(parv[1,1]) then validglinemask(parv[1]);
  gl := findgline(ircupper(parv[1]));
  if gl = nil then begin
    send(sendtalk+'no such G-line');
    exit;
  end;

  logaction(sptr,cmd+' '+parv[1]+' ('+gl.reason+')');
  delgline(sptr,parv[1]);
end;

procedure priv_glist(sptr:tuser;parc:integer;parv:pparams;const msg:string);
begin
  mc_gline(mybot,sptr,parc,parv);
end;

procedure priv_refreshg(sptr:tuser;parc:integer;parv:pparams;const msg:string);
var
  gl:tgline;
begin
  logaction(sptr,cmd);
  gl := tgline(glist);
  while gl <> nil do begin
    sendgline(gl);
    gl := tgline(gl.next);
  end;
  gl := tgline(badchanglist);
  while gl <> nil do begin
    sendgline(gl);
    gl := tgline(gl.next);
  end;
end;

{======================================================================channel management}

procedure priv_listchannels(sptr:tuser;parc:integer;parv:pparams;const msg:string);
var
  gl:tchanmanage;
begin
  send(sendtalk+'Channels managed by '+mybot.name);
  send(sendtalk+'name        default modes       added by');
  gl := tchanmanage(chanmanagelist);
  while gl <> nil do begin
    send(sendtalk+'  '+gl.name+'      '+gl.defaultmodes+'      '+gl.sender);
    gl := tchanmanage(gl.next);
  end;
end;

procedure priv_addchannel(sptr:tuser;parc:integer;parv:pparams;const msg:string);
var
  s:string;
  a,b:integer;
  gl,gl2:tchanmanage;
  ch:tchannel;
begin
  if (parv[1] = '') or (parc < 2) then begin
    send(sendtalk+cmd+' <channel> [<default modes>]');
    exit;
  end;
  s := ircupper(parv[1]);

  {valid name?}
  b := 0;
  if length(s) > 50 then b := 1;
  if s[1] <> '#' then b := 1;
  if b = 0 then begin
    for a := 2 to length(s) do if s <= #32 then b := 1;
  end;
  if b <> 0 then begin
    send(sendtalk+'Invalid channel name');
    exit;
  end;

  {channel already exists?}
  gl2 := tchanmanage(chanmanagelist);
  gl := nil;
  while gl2 <> nil do begin
    if (ircupper(gl2.name) = s) then begin
      gl := gl2;
      break;
    end;
    gl2 := tchanmanage(gl2.next);
  end;
  if gl = nil then begin
    gl := tchanmanage.create;
    linklistadd(tlinklist(chanmanagelist),tlinklist(gl));
  end;
  gl.name := parv[1];
  gl.defaultmodes := '+nt';
  gl.sender := getloginname(sptr);

  {channel exists?}
  ch := findchan(gl.name);
  if ch <> nil then gl.ts := ch.ts else gl.ts := irctime;

  if (parc >= 3) then if parv[2] <> '' then if parv[2,1] = '+' then begin
    gl.defaultmodes := parv[2];
  end;
  sendparse(mybot.idstr+' '+TOK_CREATE+' '+gl.name+' :'+inttostr(gl.ts));
  sendparse(mybot.idstr+' '+TOK_MODE+' '+gl.name+' :'+gl.defaultmodes);

  logaction(sptr,cmd+' '+parv[1]+' '+parv[2]);
end;

procedure priv_delchannel(sptr:tuser;parc:integer;parv:pparams;const msg:string);
var
  s:string;
  gl,gl2:tchanmanage;
begin
  if (parv[1] = '') or (parc < 2) then begin
    send(sendtalk+cmd+' <channel>');
    exit;
  end;
  s := ircupper(parv[1]);

  {channel exists?}
  gl2 := tchanmanage(chanmanagelist);
  gl := nil;
  while gl2 <> nil do begin
    if (ircupper(gl2.name) = s) then begin
      gl := gl2;
      break;
    end;
    gl2 := tchanmanage(gl2.next);
  end;
  if gl = nil then begin
    send(sendtalk+error_nosuchchannel(parv[1]));
    exit;
  end;
  logaction(sptr,cmd+' '+gl.name);
  sendparse(mybot.idstr+' '+TOK_PART+' '+gl.name+' :');
  linklistdel(tlinklist(chanmanagelist),gl);
  gl.destroy;
end;

{========================================================================== JUPE}

(*
procedure priv_jupe(sptr:tuser;parc:integer;parv:pparams;msg:string);
begin
  send(sendtalk+'jupe code not implemented yet');
end;

procedure priv_unjupe(sptr:tuser;parc:integer;parv:pparams;msg:string);
begin
  send(sendtalk+'jupe code not implemented yet');
end;
*)

{========================================================================= misc}

{
onsavefile(from:tuser;,filename:string)

can be used to have multiple bots use the same file for something;
one bot saves, another bot loads

}

procedure priv_set(sptr:tuser;parc:integer;parv:pparams;const msg:string);
var
  s:string;
begin
  setcommand(sptr,parc,parv,msg,bworldbot.optiontable,bworldbot.maxoptiontable,sendtalk,cmd,s);
  if s <> '' then logaction(sptr,s);
end;

procedure priv_globalset(sptr:tuser;parc:integer;parv:pparams;const msg:string);
var
  s:string;
begin
  setcommand(sptr,parc,parv,msg,bconfig.optiontable,bconfig.maxoptiontable,sendtalk,cmd,s);
  if s <> '' then logaction(sptr,s);
end;

procedure priv_settime(sptr:tuser;parc:integer;parv:pparams;const msg:string);
begin
  logaction(sptr,cmd);
  send(me.idstr+' '+TOK_SETTIME+' :'+inttostr(irctime));
end;

procedure priv_save(sptr:tuser;parc:integer;parv:pparams;const msg:string);
begin
  logaction(sptr,cmd);
  bworldbotsave;
end;

procedure priv_rehash(sptr:tuser;parc:integer;parv:pparams;const msg:string);
begin
  logaction(sptr,cmd);
  bworldbotinit;
end;

procedure priv_restart(sptr:tuser;parc:integer;parv:pparams;const msg:string);
begin
  logaction(sptr,cmd);
  bworldbotshutdown;
  onstartup;
end;

procedure priv_die(sptr:tuser;parc:integer;parv:pparams;const msg:string);
var
  a:integer;
begin
  logaction(sptr,cmd);

  shutdownreason := '';
  for a := 1 to parc-1 do begin
    if shutdownreason <> '' then shutdownreason := shutdownreason + ' ';
    shutdownreason := shutdownreason+parv[a];
  end;

  {onshutdown;}
  {die does global shutdown atm}
  globalshutdown;
  halt;
end;

procedure priv_diebot(sptr:tuser;parc:integer;parv:pparams;const msg:string);
var
  a:integer;
begin
  logaction(sptr,cmd);

  shutdownreason := '';
  for a := 1 to parc-1 do begin
    if shutdownreason <> '' then shutdownreason := shutdownreason + ' ';
    shutdownreason := shutdownreason+parv[a];
  end;

  bworldbotshutdown;
end;

procedure priv_mkpasswd(sptr:tuser;parc:integer;parv:pparams;const msg:string);
begin
  if (parc < 2) or (parv[1] = '') then begin
    send(sendtalk+cmd+' <password>');
    exit;
  end;
  send(sendtalk+passnewcrypt(parv[1]));
end;

{=======================================================================commands management}

function validcomname(s:string):boolean;
var
  a:integer;
begin
  result := false;
  if (length(s) > 15) or (s = '') then exit;
  for a := 1 to length(s) do if not (s[a] in ['A'..'Z']) then exit;
  result := true;
end;

procedure priv_level(sptr:tuser;parc:integer;parv:pparams;const msg:string);
var
  a,b:integer;
  s:string;
begin
  if (parc < 2) or (parv[1] = '') then begin
    s := '';
    for a := 0 to botmaxcmd do begin
      s := s + cmdtab[a].cmd+'='+inttostr(cmdtab[a].level)+'    ';
      if length(s) > 50 then begin
        send(sendtalk+s);
        s := '';
      end;
    end;
    if s <> '' then send(sendtalk+s);
    exit
  end;
  parv[1] := ircupper(parv[1]);
  for a := 0 to botmaxcmd do begin
    if cmdtab[a].cmd = parv[1] then begin
      if (parc > 2) and (parv[2] <> '') then
      b := strtointdef(parv[2],-2)
      else b := -2;
      if b > -2 then begin
        logaction(sptr,cmd+' '+cmdtab[a].cmd+' '+inttostr(cmdtab[a].level)+' -> '+inttostr(b));
        cmdtab[a].level := b;
      end else begin
        send(sendtalk+cmdtab[a].cmd+'='+inttostr(cmdtab[a].level));
      end;
      exit;
    end;
  end;
  send(sendtalk+'command not found: '+parv[1]);
end;

procedure savecmd;
var
  t:textfile;
  a:integer;
begin
  assignfile(t,commandsfile);
  filemode := 2;
  {$i-}rewrite(t);{$i+}
  if ioresult <> 0 then exit;
  writeln(t,'[bworld.commands]');
  for a := 0 to botmaxcmd do begin
    writeln(t,'name='+cmdtab[a].cmd);
    writeln(t,'customname='+cmdtab[a].customcmd);
    writeln(t,'level='+inttostr(cmdtab[a].level));
    writeln(t,'enabled='+inttostr(ord(cmdtab[a].enabled)));
    writeln(t);
  end;
  closefile(t);
end;

var
  currentloadcmd:integer;

procedure loadcmdproc(sv,sn:string);
var
  a:integer;
begin
  if sv = 'NAME' then begin
    sn := ircupper(sn);
    currentloadcmd := -1;
    for a := 0 to botmaxcmd do if cmdtab[a].cmd = sn then begin
      currentloadcmd := a;
      exit;
    end;
  end else
  if sv = 'CUSTOMNAME' then begin
    if currentloadcmd <> -1 then begin
      sn := ircupper(sn);
      if validcomname(sn) then cmdtab[currentloadcmd].customcmd := sn;
    end;
  end else
  if sv = 'LEVEL' then begin
    if currentloadcmd <> -1 then begin
      cmdtab[currentloadcmd].level := strtointdef(sn,maxlevel);
    end;
  end else
  if sv = 'ENABLED' then begin
    if currentloadcmd <> -1 then begin
      cmdtab[currentloadcmd].enabled := sn = '1';
    end;
  end;
end;

procedure loadcmd;
var
  a:integer;
begin
  currentloadcmd := -1;
  for a := 0 to botmaxcmd do begin
    cmdtab[a].customcmd := cmdtab[a].cmd;
    cmdtab[a].enabled := true;
  end;
  readcfg(commandsfile,@loadcmdproc);
end;

procedure priv_chcomname(sptr:tuser;parc:integer;parv:pparams;const msg:string);
var
  a:integer;
begin
  if (parc < 3) or (parv[2] = '') then begin
    send(sendtalk+cmd+' <old command name> <new command name>');
    exit
  end;
  parv[1] := ircupper(parv[1]);
  parv[2] := ircupper(parv[2]);

  {check for parv[2] be a valid command (that is, easy to type)}

  if not validcomname(parv[2]) then begin
    send(sendtalk+'bad command name');
    exit
  end;
  for a := 0 to botmaxcmd do begin
    if cmdtab[a].customcmd = parv[2] then begin
      send(sendtalk+'command '+parv[2]+' already exists, can''t change.');
      exit;
    end;
  end;
  for a := 0 to botmaxcmd do begin
    if cmdtab[a].customcmd = parv[1] then begin
      logaction(sptr,cmd+' '+cmdtab[a].customcmd+' '+parv[2]);
      cmdtab[a].customcmd := parv[2];
      exit;
    end;
  end;
  send(sendtalk+'command not found: '+parv[1]);
end;

{========================================================================oper account}

procedure priv_addoper(sptr:tuser;parc:integer;parv:pparams;const msg:string);
var
  p:tbworldaccount;
  s:string;
  a:integer;
begin
  if (parc < 3) or (parv[2] = '') then begin
    send(sendtalk+cmd+' <IDnick> <level>');
    exit
  end;

  s := convertaccountname(parv[1]);

  if not validaccountname(s) then begin
    send(sendtalk+'invalid IDnick');
    exit
  end;
  a := strtointdef(parv[2],-1);
  if a < 0 then begin
    send(sendtalk+'invalid level');
    exit;
  end;
  p := findbworldaccount(parv[1]);

  if p <> nil then begin
    send(sendtalk+'account '+p.name+' already exists.');
    exit;
  end else begin
    if haslevel(sptr) >= maxlevel then begin
      if a > haslevel(sptr) then begin
        send(sendtalk+'can''t add an account with a higher level than yourself.');
        exit;
      end;
    end else begin
      if a >= haslevel(sptr) then begin
        send(sendtalk+'No access to add an account with equal or higher level');
        exit;
      end;
    end;
    addbworldaccount(parv[1],a);
    logaction(sptr,cmd+' '+parv[1]+' '+inttostr(a));
  end;
end;

procedure priv_deloper(sptr:tuser;parc:integer;parv:pparams;const msg:string);
var
  p:tbworldaccount;
begin
  if (parc < 2) or (parv[1] = '') then begin
    send(sendtalk+cmd+' <IDnick>');
    exit
  end;
  p := findbworldaccount(parv[1]);
  if p = nil then begin
    send(sendtalk+error_nosuchaccount(parv[1]));
    exit;
  end;

  if p.level >= haslevel(sptr) then begin
    send(sendtalk+'No access to delete an account with equal or higher level');
    exit;
  end;

  logaction(sptr,cmd+' '+p.name);
  linklistdel(tlinklist(bworldaccountlist),tlinklist(p));
  p.destroy;
  {}
end;

procedure priv_modoper(sptr:tuser;parc:integer;parv:pparams;const msg:string);
var
  p:tbworldaccount;
  s,subcmd:string;
  a,b:integer;
begin
  if (parc < 3) or (parv[2] = '') then begin
    send(sendtalk+cmd+' <IDnick> <command> [<param>]');
    send(sendtalk+cmd+' commands: ADDMASK DELMASK NEWPASS LEVEL OPERONLY');
    exit
  end;
  p := findbworldaccount(parv[1]);
  if p = nil then begin
    send(sendtalk+error_nosuchaccount(parv[1]));
    exit;
  end;
  subcmd := ircupper(parv[2]);
  if subcmd = 'ADDMASK' then begin
    for a := 3 to parc-1 do begin
      s := cookmask(parv[a]);
      if not validmask(s) then begin
        send(sendtalk+'invalid mask');
      end else begin
        if p.addmask(s) then begin
          logaction(sptr,cmd+' '+subcmd+' '+p.name+' '+s);
        end else begin
          send(sendtalk+'mask already exists');
        end;
      end;
    end;
  end else if subcmd = 'DELMASK' then begin
    for a := 3 to parc-1 do begin
      s := cookmask(parv[a]);
      if p.delmask(s) then begin
        logaction(sptr,cmd+' '+subcmd+' '+p.name+' '+s);
      end else begin
        send(sendtalk+'mask does not exist');
      end;
    end;
  end else if pos('PASS',subcmd) <> 0 then begin
    if parv[3] = '' then begin
      logaction(sptr,'Account '+p.name+' disabled.');
      p.password := '';
    end else begin
      logaction(sptr,cmd+' NEWPASS '+p.name);
      if length(parv[3]) = cryptedpasslen then begin
        p.password := parv[3];
      end else begin
        p.password := passnewcrypt(parv[3]);
      end;
    end;
  end else if subcmd = 'LEVEL' then begin
    a := strtointdef(parv[3],-1);
    if a >= 0 then begin
      b := haslevel(sptr);
      if ((b < maxlevel) and (a >= b)) or (a > b) then begin
        send(sendtalk+'No access.');
        exit;
      end;
      logaction(sptr,cmd+' LEVEL '+p.name+' '+inttostr(p.level)+' -> '+inttostr(a));
      p.level := a;
    end;
  end else if subcmd = 'OPERONLY' then begin
    s := ircupper(parv[3]);
    if ((s = 'ON') or (s = '1')) and (not p.operonly) then begin
      logaction(sptr,cmd+' OPERONLY '+p.name+' ON');
      p.operonly := true
    end else if ((s = 'OFF') or (s = '0')) and (p.operonly) then begin
      logaction(sptr,cmd+' OPERONLY '+p.name+' OFF');
      p.operonly := false ;
    end;
  end else begin
    send(sendtalk+'invalid command');
  end;
end;

procedure priv_operlist(sptr:tuser;parc:integer;parv:pparams;const msg:string);
var
  p:tbworldaccount;
  s:string;
begin
  p := bworldaccountlist;
  send(sendtalk+'  IDnick        level    online');
  while p <> nil do begin
    s :=  '    '+p.name+' ';
    while length(s) < 16 do s := s + ' ';
    s := s + inttostr(p.level)+' ';
    while length(s) < 25 do s := s + ' ';
    if p.user <> nil then begin
      s := s + tuser(p.user.p).name;
    end else begin
      s := s + '-';
    end;
    send(sendtalk+s);
    p := tbworldaccount(p.next);
  end;
  send(sendtalk+'--- End of list ---');
  {}
end;

procedure priv_operinfo(sptr:tuser;parc:integer;parv:pparams;const msg:string);
var
  p:tbworldaccount;
  s:string;
  sl:tstringlinklist;
  pp:tplinklist;
begin
  if (parc < 2) or (parv[2] = '1') then begin
    send(sendtalk+cmd+' <IDnick>');
    exit;
  end;
  p := findbworldaccount(parv[1]);
  if p = nil then begin
    send(sendtalk+error_nosuchaccount(parv[1]));
    exit;
  end;
  send(sendtalk+'  Name: '#2+p.name+#2'    Level: '#2+inttostr(p.level)+#2);
  sl := p.mask;
  if sl <> nil then begin
    s := '';
    while (sl <> nil) do begin
      s := s + ' '+sl.s;
      sl := tstringlinklist(sl.next);
      if length(s) > 450 then begin
        send(sendtalk+'  masks:'#2+s);
        s := '';
      end;
    end;
    if s <> '' then send(sendtalk+'  masks:'#2+s);
  end else begin
    send(sendtalk+'  no masks.');
  end;

  if p.user = nil then begin
    send(sendtalk+'  Not logged in.');
  end else begin
    pp := p.user;
    while pp <> nil do begin
      send(sendtalk+'  Logged in: '#2+nickuserhost(tuser(pp.p)));
      pp := tplinklist(pp.next);
    end;
  end;

  if p.operonly then send(sendtalk+'  Must be IRCop to log in');
  if p.password = '' then send(sendtalk+'  Account disabled.');

  send(sendtalk+'--- End of info ---');
  {}
end;

procedure priv_mem(sptr:tuser;parc:integer;parv:pparams;const msg:string);
var
  {$ifdef fpc}
    hs:tmemorymanager;
    
  {$else}
    hs:theapstatus;
  {$endif}
begin
  {$ifdef fpc}
    getmemorymanager(hs);

    send(sendtalk+inttostr(hs.heapsize()-memavail));
  {$else}

    hs := getheapstatus;
    send(sendtalk+inttostr(hs.totalallocated));
  {$endif}
end;

procedure priv_exceptionlist(sptr:tuser;parc:integer;parv:pparams;const msg:string);
var
  p:tban;
  s:string;
begin
  p := exceptionlist;
  send(sendtalk+'clone limit exception list');
  send(sendtalk+'  IP mask                     new limit  sender');
  while p <> nil do begin
    s :=  '    '+p.mask+' ';
    while length(s) < 32 do s := s + ' ';
    s := s + inttostr(p.date)+' ';
    while length(s) < 43 do s := s + ' ';
    s := s + p.sender;
    send(sendtalk+s);
    p := tban(p.next);
  end;
  send(sendtalk+'--- End of list ---');
  {}
end;

procedure priv_addexception(sptr:tuser;parc:integer;parv:pparams;const msg:string);
var
  s:string;
  gl,gl2:tban;
begin
  if (parv[2] = '') or (parc < 3) then begin
    send(sendtalk+cmd+' <mask> <new limit>');
    exit;
  end;

  if pos('@',parv[1]) = 0 then parv[1] := '*@'+parv[1];

  s := ircupper(parv[1]);

  if not validmask(s) then begin
    send(sendtalk+'Invalid mask');
    exit;
  end;

  {entry already exists?}
  gl2 := tban(exceptionlist);
  gl := nil;
  while gl2 <> nil do begin
    if (ircupper(gl2.mask) = s) then begin
      gl := gl2;
      break;
    end;
    gl2 := tban(gl2.next);
  end;
  if gl = nil then begin
    gl := tban.create;
    linklistadd(tlinklist(exceptionlist),tlinklist(gl));
  end;
  gl.mask := parv[1];
  gl.date := strtointdef(parv[2],0);
  gl.sender := getloginname(sptr);

  logaction(sptr,cmd+' '+parv[1]+' '+parv[2]);
end;

procedure priv_delexception(sptr:tuser;parc:integer;parv:pparams;const msg:string);
var
  s:string;
  gl,gl2:tban;
begin
  if (parv[1] = '') or (parc < 2) then begin
    send(sendtalk+cmd+' <mask>');
    exit;
  end;
  if pos('@',parv[1]) = 0 then parv[1] := '*@'+parv[1];

  s := ircupper(parv[1]);

  {exception exists?}
  gl2 := tban(exceptionlist);
  gl := nil;
  while gl2 <> nil do begin
    if (ircupper(gl2.mask) = s) then begin
      gl := gl2;
      break;
    end;
    gl2 := tban(gl2.next);
  end;
  if gl = nil then begin
    send(sendtalk+'exception not found: '+parv[1]);
    exit;
  end;
  logaction(sptr,cmd+' '+gl.mask);
  linklistdel(tlinklist(exceptionlist),gl);
  gl.destroy;
end;

{============================================================================}

procedure onprivmsg(nickatserver:boolean;sptr:tuser;target:tuser;s:string);
var
  parv:tparams;
  parc:integer;
  a,b:integer;
  bool:boolean;
begin
  parc := strtok(s,' ',@parv);
  cmd := ircupper(parv[0]);
  if cmd = '' then exit;
  sendtalk := sendtalkstr(mybot,sptr);
  b := -1;
  bool := ismortal(sptr);
  for a := 0 to botmaxcmd do begin
    if cmd = cmdtab[a].customcmd then begin
      if haslevel(sptr) >= cmdtab[a].level then begin
        if @cmdtab[a].p <> nil then cmdtab[a].p(sptr,parc,@parv,s);
        b := 0;
      end else begin
        b := 1;
      end;
    end;
    if bool then exit; {LOGIN must be first entry of cmdtable}
  end;
  if b < 0 then begin

    {handle CTCP requests}
    if cmd[1] = #1 then begin
      if cmd = #1'VERSION'#1 then begin
        send(sendtalk+#1'VERSION '+versioninfostr+' '+versionstr+'. BWorld operator service.'#1);
        exit;
      end else
      if copy(cmd,1,5) = #1'PING' then begin
        send(sendtalk+#1'PING '+parv[1]);
        exit;
      end
    end;
    send(sendtalk+'Unknown command');
  end else if b = 1 then begin
    send(sendtalk+'No access');
  end;
end;

procedure onstartup;
begin
  if up then exit;
  up := true;
  currentoperchannel := '';
  bworldbotinit;
  mybot := addbot(srvunit,locopt.nick,locopt.userid,'',locopt.info,usermode_service or usermode_oper or usermode_invisible);
  prefix := sendprefixstr(mybot);
  if locopt.operchannel <> '' then begin
    bot_join(mybot,locopt.operchannel,true,globaldefaultts);
    sendparse(prefix+TOK_MODE+' '+locopt.operchannel+' +ntsi');
    currentoperchannel := locopt.operchannel;
  end;
  bworldbotinit;
  logaction(nil,'startup');
end;

procedure ontimer;
begin
  if opt.autosave <> 0 then if (unixtime >= autosavenextts) then begin
    logaction(nil,'autosave');
    bworldbotsave;
  end;
  b_gline.timehandler;
end;

procedure onnewuser;
var
  gl:tgline;
  s:string;
  s2:string;
  a,b:integer;
  ex:tban;
  bm:tbanmask;
begin
  {clone limit check}
  s := ircupper(us.userid+'@'+us.host);
  s2 := ircupper(us.userid+'@'+ipbintostr(us.binip));


  a := us.binip;
  if a = 0 then exit;
  if locopt.clonelimit <= 0 then exit;
  assert(us.ipcheck <> nil,'clone limit: us.ipcheck is not assigned','');
  b := locopt.clonelimit;

  if b > 0 then if us.ipcheck.online > b then begin
    {exception?}
    ex := exceptionlist;
    while ex <> nil do begin
      if maskmatch(ircupper(ex.mask),s2) then begin
        if ex.date > b then b := ex.date;
        if ex.date = 0 then b := maxlongint;
      end;
      ex := tban(ex.next);
    end;

    if us.ipcheck.online > b then begin
      logaction(nil,'Clone limit G-line on '+ipbintostr(us.binip)+', '+inttostr(us.ipcheck.online)+' clones.');
      addgline('-clone','*@'+ipbintostr(us.binip),parseduration(locopt.cloneduration),locopt.clonereason);
      exit;
    end;
  end;

  banmaskmake_oneuser(@bm,us.userid,us.host,us.binip);

  gl := tgline(glist);
  while gl <> nil do begin
    if banmaskmatch(@gl.m,@bm) then
    if gl.date >= irctime then
    if flag_isset(gl.flags,glineflag_active) then begin
      sendgline(gl);
      exit
    end;
    gl := tgline(gl.next);
  end;
end;

procedure ondestroyuser;
begin
  deauth(us);
  {}
end;

procedure onsendburst;
begin
  {}
end;

procedure ondisconnect;
begin
  {}
end;

procedure onrehash;
begin
  if not up then exit;
  logaction(nil,'Received REHASH signal');
  bworldbotinit;
end;

procedure bworldbotshutdown;
begin
  if not up then exit;
  up := false;

  logaction(nil,'shutdown: '+shutdownreason);

  bworldbotsave;

  cleargline;
  clearjupe;
  clearchan;
  clearbworldaccount;

  bot_quit(mybot,shutdownreason);
  mybot := nil;
  currentoperchannel := '';
end;

procedure reg;
begin
  srvunit := createserviceunit;
  srvunit.name := 'BWorld';
  @srvunit.onstartup := @onstartup;
  @srvunit.onshutdown := @bworldbotshutdown;
  @srvunit.onprivmsg := @onprivmsg;
  @srvunit.ontimer := @ontimer;
  @srvunit.onsave := @onsave;
  @srvunit.onnewuser := @onnewuser;
  @srvunit.ondestroyuser := @ondestroyuser;
  @srvunit.onrehash := @onrehash;
  if not registerserviceunit(srvunit) then srvunit.destroy;
end;


begin
  reg;
end.
